# -*- coding: utf-8 -*-
"""
Created on Wed Nov 22 20:10:30 2017

@author: Samuel
"""

"""Linear Regression 2 - Exercises"""

# In the exercises below we will investigate how robust our models are from 
# exercise 1. 

"""
Exercise 1 - Slide 13

Exercise 1. Read in the data and split into lower, middle, and high income
level assigning a new variable 'IncomeLevel' to 1, 2, and 3 respectively. Run
simple linear regression models for predicting total revenue spent from 
distance to arena for each of the three income levels. Plot the distribution of
residuals and compute the variance of the residuals for each. What do these 
tell you about our 3 models?

"""

"""
Exercise 2- Slide 22

Exercise 2. Test for normality of our three models by creating Q-Q plots.
Also overlay scatter plots with our SLR models with 90% confidence intervals.
You can change the amount of confidence you want in sns.lmplot with the 
parameter "ci" set to an integer between 0 and 100. Plot the residuals vs. 
fitted values of our models. What does these visualizations tell you regarding 
the assumptions of linear regression.
"""

"""
Exercises 3&4 at Slide 76:

Exercise 3 - Slide 76

Exercise 3. Test formally for heteroscedasticity using the Breusch-Pagan test.
What are the conclusions of this? Also compute the influence of each point
for all three models with Cook's distance. Are there any patterns with these
potential outliers? Considering coloring these points differently on scatter
plots. 
"""


"""
Exercise 4 - Slide 76

Exercise 4. Let's add the variables GamesWatched and FanComplaints to our 
models. Test for heteroscedasticity, normality of residuals, and 
multicollinearity.
"""
"""

Exercise 5 - Slide 92


Exercise 5. For each of our three income levels, randomly split the data
using "train_test_split" function from the sklearn.model_selection module.
Make the test size 20%. Refit our models using the other 80% of the data.
Predict the total revenue for the last 20%. To see how well our predictions
do, compute the mean squared between our predictions and the actual total 
revenue spent values in the test set. You can do this in either scikit-learn
or statsmodels.

Note our train_test_split should look like:
    x_train, x_test = train_test_split(data, test_size=.2)
"""
